/*
; Fields CG Zip Code : jQuery version
; Recuperation des donnees GPS, nom d'une ville depuis geo.api.gouv.fr
; Version			: 1.0.3
; Package			: Joomla 3.9.x / 4.0
; copyright 		: Copyright (C) 2019 ConseilGouz. All rights reserved.
; license    		: http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
; Updated on        : December, 2019
; Version 01.0.3    : initial version
; depuis une idée de Yann (alias Daneel) dans son module MeteoFr suite à une discussion du forum Joomla : https://forum.joomla.fr/forum/joomla-3-x/administration/gestion-des-articles-ad/226900-article-non-s%C3%A3%C2%A9curis%C3%A3%C2%A9-en-https-avec-la-vignette-m%C3%A3%C2%A9t%C3%A3%C2%A9o-france
; adaptation pour récupérer les codes GPS de la ville et vérification du nombre de reponses
*/
var timeout,callDelay=500,
apiUrl="https://public.opendatasoft.com/api/records/1.0/search/?dataset=correspondance-code-insee-code-postal&q=",
apiWorld="https://nominatim.openstreetmap.org/search?format=json&addressdetails=1&country=";

jQuery(document).ready(function($){
	// opendatasoft request : France only
	$('input.cgzipcode').on("click mouseup keyup",function(){
		maxlength = $('#cgzipfid').data('maxlength');
		if (jQuery(this).val().length < maxlength ) {$(".cgcity").val("").html(""),$(".cginsee").val("").html(""),$(".cglong").val("").html(""),$(".cglat").val("").html(""); $(".cglibs").css('display', 'none');return}
		country = $('#cgzipfid').data('country');
		var e=$(this).val();
		if (country=='fr') {
			url = apiUrl;
			getZipFr($,e,url,maxlength)
		} else {
			url=apiWorld+country+"&accept-language="+country+"&postalcode="; 
			getZipWorld($,e,url,maxlength)
		}
	})
});
function getZipFr($,e,url,maxlength) {
	$("#cg_result").html("Chargement..."),timeout&&clearTimeout(timeout),
	timeout=setTimeout(function(){$.getJSON(url+e,function(r){
			$val = $("#cgzipfid").val();
			$res = $("#"+$val);
			r.nhits != 1&&($("#cg_result").html("Vous avez "+r.nhits+" resultat(s). veuillez préciser votre demande."),$(".cgcity").val("").html(""),$(".cginsee").val("").html(""),$(".cglong").val("").html(""),$(".cglat").val("").html(""),$(".cglibs").css('display', 'none')),
			r.nhits ===1&&r.parameters.q===e&&($("#cg_result").html(""),$(".cgcity").html(r.records[0].fields.nom_comm).val(r.records[0].fields.nom_comm),
				$(".cginsee").html(r.records[0].fields.insee_com).val(r.records[0].fields.insee_com),$(".cglat").html(r.records[0].fields.geo_point_2d[0].toString().substring(0,8)).val(r.records[0].fields.geo_point_2d[0].toString().substring(0,8)),$(".cglong").html(r.records[0].fields.geo_point_2d[1].toString().substring(0,8)).val(r.records[0].fields.geo_point_2d[1].toString().substring(0,8)),$("input.cgzipcode").val(r.records[0].fields.postal_code.substring(0,maxlength)),$(".cglibs").css('display', 'block')
				,$res.val(r.records[0].fields.postal_code.substring(0,maxlength)+'|'+r.records[0].fields.nom_comm+'|'+r.records[0].fields.insee_com+'|'+r.records[0].fields.geo_point_2d[0].toString().substring(0,8)+'|'+r.records[0].fields.geo_point_2d[1].toString().substring(0,8))
				)}
		)},callDelay);
}
function getZipWorld($,e,url,maxlength) {
	$("#cg_result").html("Chargement..."),timeout&&clearTimeout(timeout),
	$val = $("#cgzipfid").val();
	$res = $("#"+$val);
	timeout=setTimeout(function(){$.getJSON(url+e,function(r){
				r.length != 1&&($("#cg_result").html("Vous avez "+r.length+" resultat(s). veuillez préciser votre demande."),$(".cglong").val(""),$(".cglat").val("")),
				r.length ===1&&($("#cg_result").html(""),$('.cgcity').html(r[0].display_name).val(r[0].display_name),
				$(".cginsee").html(r[0].place_id).val(r[0].place_id),$(".cglat").html(r[0].lat.toString().substring(0,8)).val(r[0].lat.toString().substring(0,8)),$(".cglong").html(r[0].lon.toString().substring(0,8)).val(r[0].lon.toString().substring(0,8)),$("input.cgzipcode").val(r[0].address.postcode),$(".cglibs").css('display', 'block')
				,$res.val(r[0].address.postcode+'|'+r[0].display_name+'|'+r[0].place_id+'|'+r[0].lat.toString().substring(0,8)+'|'+r[0].lon.toString().substring(0,8))
				)}
		)},callDelay);
}