/*
; Fields CG Zip Code : VueJS version
; Recuperation des donnees GPS, nom d'une ville depuis geo.api.gouv.fr
; Version			: 1.0.3
; Package			: Joomla 3.9.x / 4.0
; copyright 		: Copyright (C) 2019 ConseilGouz. All rights reserved.
; license    		: http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
; Updated on        : December, 2019
; Version 1.0.3     : initial version
; depuis une idée de Yann (alias Daneel) dans son module MeteoFr suite à une discussion du forum Joomla : https://forum.joomla.fr/forum/joomla-3-x/administration/gestion-des-articles-ad/226900-article-non-s%C3%A3%C2%A9curis%C3%A3%C2%A9-en-https-avec-la-vignette-m%C3%A3%C2%A9t%C3%A3%C2%A9o-france
; adaptation pour récupérer les codes GPS de la ville et vérification du nombre de reponses
*/
var timeout,callDelay=500,
apiUrl="https://public.opendatasoft.com/api/records/1.0/search/?dataset=correspondance-code-insee-code-postal&q=",
apiWorld="https://nominatim.openstreetmap.org/search?format=json&addressdetails=1&featuretype=city&country=";
var cgzipvue = new Vue({
	el: '#cgzipcodewatch',
	created: function() {
		this.debouncedGetAnswer = _.debounce(this.getAnswer, 500)	
	},
	mounted: function() {
		this.mycountry = this.$refs.cgzip.attributes["data-country"].value
		this.zipinfo = this.$refs.cgzip.value
		if (this.zipinfo) {
			res = this.zipinfo.split('|')
			this.cgzipcode = this.cgzipcodeinit = res[0]
			this.cgcity = res[1], this.cginsee = res[2], this.cglong = res[3], this.cglat = res[4]
			this.valdisplay = 'inline-block'
		}
	},
	data : { 
		mycountry : '',cgzipcode : '',cgzipcodeinit : '',
		cg_result : '', cglat : '', cglong : '', cginsee : '', cgcity : '',
		valdisplay : 'none'
	},
	watch: {
		cgzipcode: function (newZip, oldZip) {
			// Waiting for you to stop typing....
			this.debouncedGetAnswer()
		}
	},
	methods: {
		getAnswer: function () {
			if ((this.cgzipcode.length < 5) || (this.cgzipcode == this.cgzipcodeinit)) {
				return
			}
			this.cg_result = 'Thinking...'
			var vm = this
			axios.get(apiUrl+this.cgzipcode).then(function (response) {
				if (response.data.nhits != 1) {
					vm.cg_result = response.data.nhits+' réponse(s)...'
				} else {
					res = response.data.records[0].fields
					vm.cg_result = ''
					vm.cgcity = res.nom_comm, vm.cginsee = res.insee_com, vm.cglong = res.geo_point_2d[0].toString().substring(0,7), vm.cglat = res.geo_point_2d[1].toString().substring(0,7)
					vm.$refs.cgzip.value = res.postal_code.substring(0,5) + '|' + res.nom_comm+'|'+res.insee_com+'|'+vm.cglong+'|'+ vm.cglat
					vm.valdisplay = 'inline-block'
					vm.cgzipcodeinit = vm.cgzipcode = res.postal_code.substring(0,5)
					updateClass('cgcity',vm.cgcity), updateClass('cginsee',vm.cginsee), updateClass('cglong',vm.cglong), updateClass('cglat',vm.cglat)
				}
            }).catch(function(error) {
				vm.cg_result = 'Error....'+error;
			});			
		}
	}
})
function updateClass(classname, classvalue) {
  var x = document.getElementsByClassName(classname);
  var i;
  for (i = 0; i < x.length; i++) {
    x[i].value = classvalue;
  }
}
